#ifndef f00CubeH
#define f00CubeH


#include "f00Object.h"


class f00Cube : public f00Object
{
	public:

		f00Cube(		GLfloat x = 0.0,
						GLfloat y = 0.0,
						GLfloat z = 0.0,
						GLfloat yaw = 0.0,
						GLfloat pitch = 0.0,
						GLfloat roll = 0.0	);


		~f00Cube();


		void
		renderObject();


		GLfloat
		size()						{ return d_size; }

		void
		size( GLfloat size )		{ d_size = size; }


		void
		setTexturedMode()			{ d_isTextured = true; }

		bool
		isTexturedMode()			{ return d_isTextured == true; }


		void
		setSprayColorMode()		{ d_isTextured = false; }

		bool
		isSprayColorMode()		{ return d_isTextured == false; }


		void
		setTextureQualityFlag( bool hiQualityFlag, bool forceUpdate = false );

		bool
		getTextureQualityFlag()	{ return d_hiQualityFlag; }


	// Internal stuff.
	protected:

		void
		drawPanel();


	// Data members.
	private:

		GLfloat			d_size;
		bool				d_isTextured;
		bool				d_hiQualityFlag;
		

};


#endif

