//#include <windows.h> jun
//#pragma hdrstop jun


#include "f00Object.h"


f00Object::f00Object(	GLfloat x,
								GLfloat y,
								GLfloat z,
								GLfloat yaw,
								GLfloat pitch,
								GLfloat roll	)
:	d_x( x ),
	d_y( y ),
	d_z( z ),
	d_yaw( yaw ),
	d_pitch( pitch ),
	d_roll( roll ),
	d_xDelta( 0.0 ),
	d_yDelta( 0.0 ),
	d_zDelta( 0.0 ),
	d_yawDelta( 0.0 ),
	d_pitchDelta( 0.0 ),
	d_rollDelta( 0.0 )
{
}


f00Object::~f00Object()
{
}


void
f00Object::render()
{
	glPushMatrix();

	renderObject();

	glPopMatrix();
}


void
f00Object::resetRot()
{
	d_yaw = 0.0;
	d_roll = 0.0;
	d_pitch = 0.0;
}


void
f00Object::resetRotDelta()
{
	d_yawDelta = 0.0;
	d_rollDelta = 0.0;
	d_pitchDelta = 0.0;
}


void
f00Object::resetPos()
{
	d_x = 0.0;
	d_y = 0.0;
	d_z = 0.0;
}


void
f00Object::resetPosDelta()
{
	d_xDelta = 0.0;
	d_yDelta = 0.0;
	d_zDelta = 0.0;
}


//
// Virtuals
//


void
f00Object::renderObject()
{
	glTranslatef( d_x, d_y, d_z );
	glRotatef( d_yaw,		0.0, 1.0, 0.0 );
	glRotatef( d_pitch,	1.0, 0.0, 0.0 );
	glRotatef( d_roll,	0.0, 0.0, 1.0 );
}


void
f00Object::reset()
{
	resetRot();
	resetRotDelta();
	resetPos();
	resetPosDelta();
}


void
f00Object::update()
{
	yawBy( d_yawDelta );
	pitchBy( d_pitchDelta );
	rollBy( d_rollDelta );

	moveBy( d_xDelta, d_yDelta, d_zDelta );
}



