#ifndef f00Point2DH
#define f00Point2DH


#include <GL/gl.h>


class f00Point2D
{
	public:

		// Must point to an array of 2 or more GLfloats: u, v
		f00Point2D( GLfloat* pArray );

		f00Point2D( GLfloat u = 0.0, GLfloat v = 0.0 );

		f00Point2D( const f00Point2D& copyFrom );


		f00Point2D&
		operator = ( const f00Point2D& copyFrom );


		static GLdouble
		length( const f00Point2D& pointA );

		GLdouble
		length() const;


		static void
		normalize( f00Point2D& pointA );

		void
		normalize();


		// Ownership *stays* in f00Point2D!
		const GLfloat*
		getArray() const
		{
			return d_array;
		}


		GLfloat
		u() const
		{
			return d_u;
		}

		GLfloat
		v() const
		{
			return d_v;
		}


		GLfloat&
		uRef()
		{
			return d_u;
		}

		GLfloat&
		vRef()
		{
			return d_v;
		}


		void
		u( GLfloat u )
		{
			d_u = u;
		}

		void
		v( GLfloat v )
		{
			d_v = v;
		}


		f00Point2D&
		set( const f00Point2D& copyFrom )
		{
			*this = copyFrom;
			return *this;
		}


		f00Point2D&
		set( GLfloat u = 0.0, GLfloat v = 0.0 )
		{
			d_u = u;
			d_v = v;
			return *this;
		}


	private:

		GLfloat					d_array[ 2 ];

		GLfloat&					d_u;
		GLfloat&					d_v;

};


#endif

